import java.awt.Image;
import java.awt.Frame;
import java.awt.Button;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Panel;
import java.awt.Event;
import java.awt.Label;
import java.awt.Scrollbar;
import java.awt.Graphics;
import java.awt.TextField;
import java.awt.Color;
import java.awt.image.ColorModel;
import java.awt.image.IndexColorModel;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
import java.util.Hashtable;
import java.lang.System;

class Animator extends Frame implements Callback
{
Image origimg,cal;
int width,height,pixels,frame;
double fld[],fldo[],nfld[];
int intimg[];
AnimatorCanvas canvas;
int mapto[];
static final int INVALID_COLOR=0;
Button BRestart,BStep,BPlay,BStop,BClose;
TextField TFrame;
Scrollbar SAccel;
Label LAccel;
int vAccel=0;
double accelv[];
boolean playing;
ColorModel mycm;

  Animator(Image img,int _width,int _height)
	{
		super("Simulating thermal distribution...");
		origimg=img; /*createImage(img.getSource())*/;
		width=_width; height=_height;
		fld=new double[pixels=width*height];
		fldo=new double[pixels];
		intimg=new int[pixels];

		mapto=new int[101];
		byte cmred[]=new byte[101],cmgreen[]=new byte[101],cmblue[]=new byte[101];
		for (int i=0;i<=100;i++){
			Color c=new Temp(i).c;
			cmred  [i]=(byte)c.getRed  ();
			cmgreen[i]=(byte)c.getGreen();
			cmblue [i]=(byte)c.getBlue ();
			}
		mycm=new IndexColorModel(8,101,cmred,cmgreen,cmblue);

		Panel control=new Panel();
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		GridBagLayout gbl=new GridBagLayout();
		control.setLayout(gbl);

		BRestart=new Button("Restart"); control.add(BRestart);
		BStep=new Button("Step"); control.add(BStep);
		BPlay=new Button("Play"); control.add(BPlay);
		BStop=new Button("Stop"); control.add(BStop);
		BClose=new Button("Close"); control.add(BClose);
		Panel panframe=new Panel();
		panframe.setLayout(new GridBagLayout());
		panframe.add(new Label("Frame:"));
		TFrame=new TextField("0",4);
		panframe.add(TFrame);
		control.add(panframe);
		gbl.setConstraints(panframe,gbc);
		Panel panaccel=new Panel();
		panaccel.setLayout(new GridBagLayout());
		panaccel.add(new Label("Acceleration:"));
		SAccel=new Scrollbar(Scrollbar.HORIZONTAL,1,3,1,10);
		panaccel.add(SAccel);
		LAccel=new Label("-");
		panaccel.add(LAccel);
		control.add(panaccel);
		gbl.setConstraints(panaccel,gbc);

		setLayout(new FlowLayout());
		Panel panel=new Panel();
		panel.setLayout(gbl);

		canvas=new AnimatorCanvas(width,height,this);
		reinit();
		updateAccel();
		panel.add(canvas);
		gbl.setConstraints(canvas,gbc);
		panel.add(control);
		add(panel);
		pack();
		move(10,250);
    setResizable(false);
		toFront();
		show();
		move(10,250);
	}

	void enables()
	{
		BRestart.enable(frame!=0);
		BPlay.enable(cal!=null && playing==false);
		BStop.enable(cal!=null && playing==true);
		TFrame.setText(new Integer(frame).toString());
	}

	void replace()
	{
		if (cal==null) {
			canvas.setImage(null);
			return;
			}
		TimeIt t=new TimeIt("replace/generate");
		for (int x=0;x<pixels;x++) {
		int v=(int)fld[x];
			if (v<0) v=0; else if (v>100) v=100;
			intimg[x]=v;
			}
		t.end();
		t=new TimeIt("replace/imaging");
		canvas.setImage(createImage(new MemoryImageSource(width,height,mycm,intimg,0,width)));
		t.end();
	}

	void reinit()
	{
		int i;
		frame=0;
		playing=false;
		if (cal!=null) {
			Graphics calg;
			int cali[]=new int[101];
			Hashtable hash=new Hashtable(101);
			try {
				PixelGrabber pg=new PixelGrabber(origimg,0,0,width,height,intimg,0,width);
				pg.grabPixels();
				if ((pg.status() & ImageObserver.ABORT)!=0) dispose();
				}
			catch (Exception e) { dispose(); }
			calg=cal.getGraphics();
			for (i=0;i<=100;i++) {
				calg.setColor(new Temp(i).c);
				calg.drawLine(i,0,i,0);
				}
			try {
				PixelGrabber pg=new PixelGrabber(cal,0,0,101,1,cali,0,101);
				pg.grabPixels();
				if ((pg.status() & ImageObserver.ABORT)!=0) dispose();
				}
			catch (Exception e) { dispose(); }
			cal.flush();
			for (i=0;i<=100;i++) hash.put(new Integer(cali[i]),new Integer(i));
//			for (i=0;i<=100;i++) System.out.println("cali["+new Integer(i).toString()+"]="+new Integer(cali[i]).toString()+"=("+new Integer((cali[i]>>24)&0xFF).toString()+")("+new Integer((cali[i]>>16)&0xFF).toString()+")("+new Integer((cali[i]>>8)&0xFF).toString()+")("+new Integer((cali[i]>>0)&0xFF).toString()+")");
			for (int x=0;x<pixels;x++) {
				Object o=hash.get(new Integer(intimg[x]));
				if (o!=null) fld[x]=((Integer)o).intValue();
				else fld[x]=INVALID_COLOR;
				}
	//		for (int x=0;x<pixels;x++) fld[x]=((double)(x*100))/pixels;
			}
		enables();
		replace();
	}

	void mathstep_3()
	{
	int x,y;
		/* for (x=1;x<pixels;x++) fld[x-1]=fld[x]; */
	double sqrt2=1D/Math.sqrt(2);
	int valc=8;

		for (x=0;x<width;x++) {
			nfld[x]=fld[x];
			nfld[x+width*(height-1)]=fld[x+width*(height-1)];
			}
		for (y=0;y<pixels;y+=width) {
			nfld[y]=fld[y];
			nfld[y+width-1]=fld[y+width-1];
			}
		for (x=1;x<width-1;x++)
			for (y=1;y<height-1;y++) {
int p=x+y*width;
double d4=4*fld[p];

				nfld[p]=((fld[p-width-1]
				         +fld[p-width+1]
				         +fld[p+width-1]
				         +fld[p+width+1]-d4)*sqrt2+
				         (fld[p-width  ]
				         +fld[p-1      ]
				         +fld[p+1      ]
				         +fld[p+width  ]-d4))/valc+fld[p];
				}
	}

	void mathstep_n()
	{
	int x,y,xr,yr;
	int vAccel2=vAccel/2;
	double sum,cur;

		for (x=0;x<width ;x++)
		for (y=0;y<height;y++) {
			cur=fld[y*width+x];
			sum=0;
			for (xr=-vAccel2;xr<=+vAccel2;xr++)
			for (yr=-vAccel2;yr<=+vAccel2;yr++) {
				if (xr==0 && yr==0) continue;
int xa=x+xr,ya=y+yr;
				if (xa<0) xa=0; if (xa>=width ) xa=width -1;
				if (ya<0) ya=0; if (ya>=height) ya=height-1;
				sum+=(fld[ya*width+xa]-cur)*accelv[(yr+vAccel2)*vAccel+(xr+vAccel2)];
				}
			nfld[y*width+x]=cur+sum/(vAccel*vAccel-1);
			}
	}

	void fullstep()
	{
TimeIt t;
		nfld=fldo;
		t=new TimeIt("mathstep");
		if (vAccel==3) mathstep_3();
		else           mathstep_n();
		t.end();
		fldo=fld;
		fld=nfld;
		frame++;
		enables();
		t=new TimeIt("replace" ); replace (); t.end();
		replace();
	}

	public void callback()
	{
		if (cal==null) {
			cal=createImage(101,1);
			reinit();
			return;
			}
		if (playing) fullstep();
	}

	public final boolean action(Event evt, Object arg)
	{
		if(evt.target instanceof Button) {
			     if (evt.target==BRestart) {
				reinit  ();
				return true; }
			else if (evt.target==BStep   ) {
				playing=false; enables();
				fullstep();
				return true; }
			else if (evt.target==BPlay   ) {
				playing=true; enables();
				fullstep();
				return true; }
			else if (evt.target==BStop   ) {
				playing=false; enables();
				return true; }
			else if (evt.target==BClose  ) {
				dispose();
				return true; }
			}
		return false;
	}

	public void updateAccel()
	{
	int now,val,x,y;

		val=SAccel.getValue();
		now=val*2+1;
		if (now==vAccel) return;
		vAccel=now;
		accelv=new double[vAccel*vAccel];
		for (y=0;y<vAccel;y++)
		for (x=0;x<vAccel;x++) {
double q;
			if (x==val && y==val)
			     q=1;
			else q=1D/Math.sqrt((x-val)*(x-val)+(y-val)*(y-val));
			accelv[y*vAccel+x]=q;
//			System.out.println("Calc["+new Integer(x-val).toString()+","+new Integer(y-val).toString()+"]="+new Double(q).toString());
			}
		LAccel.setText(new Integer(vAccel).toString());
	}

	public boolean handleEvent(Event event)
	{
		if (event.id == Event.WINDOW_DESTROY) {
			dispose();
			return true;
			}
		else if (event.target == SAccel) {
			updateAccel();
			return true;
			}
		else return super.handleEvent(event);
	}
}
